Base.Preloader = function(game) {
    this.preloadBar = null;
    this.ready = false;
    this.State = 0;
};

Base.Preloader.prototype = {
    
    preload: function () {

        Base.clear();
        Base.firstThings();

        this.load.onLoadComplete.add(this.loadComplete, this);

        this.State = 0;
      //  this.sgLoadedFlag = false;
        this.loadedSave = false;

        this.BgImg = null;
        this.AtlasLoadedFlag = false;

        this.GroupBase = this.add.group();

        this.Group0 = this.make.group();
        this.GroupBase.add(this.Group0);

        this.Group0.scale.set(Base.Scale);

        this.preloadBarBack = null;
        this.preloadBar = null;


  /*      this.GroupDebug = this.add.group(); // TEMP
        this.GroupDebug.scale.set(Base.Scale); // TEMP
        this.GroupBase.add(this.GroupDebug); // TEMP

        var bmp = this.game.make.bitmapData(32, 32);
        bmp.fill(255,255,255);
        this.cache.addImage('sqwhite','',bmp.canvas);

        bmp = this.game.make.bitmapData(32, 32);
        bmp.fill(0,0,0);
        this.cache.addImage('sqblack','',bmp.canvas);

        var x = 10;  if(this.game.device.firefox)  x = 50;
        this.WhiteImgs = [];
        for(var i=0;i<9;i++) {
            this.WhiteImgs[i] = this.make.image(x, 10 + 50 * i, 'sqwhite');
            this.GroupDebug.add(this.WhiteImgs[i]);
        }
        this.BlackImgs = [];
        for(i=0;i<9;i++) {
            this.BlackImgs[i] = this.make.image(x, 10 + 50 * i, 'sqblack');
            this.GroupDebug.add(this.BlackImgs[i]);
        }
 */

        this.TimerFunc = function()
        {
           this.checkScreenChange();

            if( this.load.isLoading )
               sdkHandler.trigger('loading.update', { progressPercentage: this.load.progress}, this);

            if((!this.AtlasLoadedFlag) && this.game.cache.checkImageKey('loaderatlas')) {
                this.AtlasLoadedFlag = true;
                // load all when ready

                this.BgImg = this.make.image(Base.Xc, Base.Yc, 'loaderatlas','bgsmall.png');
                if(this.BgImg!=null)
                  this.BgImg.scale.set(Base.WidthGame/200,Base.HeightGame/200);
                this.BgImg.anchor.setTo(0.5);
                // this.Group0.add(this.BgImg);

                this.preloadBarBack = this.make.image(Base.Xc, Base.Yc, 'loaderatlas','sliderbg.png');
                this.preloadBarBack.anchor.setTo(0.5, 0.5);
                // this.Group0.add(this.preloadBarBack);

                this.preloadBar = this.make.image(Base.Xc, Base.Yc+1,'loaderatlas','slider.png');
                this.preloadBar.anchor.setTo(0.5, 0.5);
                // this.Group0.add(this.preloadBar);

                var frameData = this.cache.getFrameData('loaderatlas');
                this.PreloaderWidth = frameData.getFrameByName('sliderbg.png').width;
                this.preloadBar.x -= this.PreloaderWidth/2;
                this.preloadBar.anchor.setTo(0, 0.5);
                // this.load.setPreloadSprite(this.preloadBar);

                this.AdjustSize();
            }

            /*if(this.State==1)
            {
                this.Group0Alpha-=0.1;
                if(this.Group0Alpha<=0) this.Group0Alpha = 0;
                this.Group0.setAll('alpha',this.Group0Alpha);
            } */
        };

        this.TimerEvt = this.game.time.events.loop(30,this.TimerFunc, this);

     //   this.load.bitmapFont('NumFont', 'fonts/num.png', 'fonts/num.fnt');
        this.load.json('language', 'lang/lang.json');

     //  var phaserJSON = game.cache.getJSON('language');
        //phaserJSON.name
       // this.load.bitmapFont('MainFont', 'fonts/main.png', 'fonts/main.fnt');
        this.load.bitmapFont('GoldFont', 'fonts/gold.png', 'fonts/gold.fnt');
     //   this.load.bitmapFont('NumBigFont', 'fonts/numbig.png', 'fonts/numbig.fnt');
      //  this.load.bitmapFont('BigFont', 'fonts/big.png', 'fonts/big.fnt');



        if(this.game.device.firefox)
        {
            this.load.audio('music', 'audioogg/music.ogg');
            this.load.audio('button', 'audioogg/button.ogg');
            this.load.audio('merge0', 'audioogg/merge0.ogg');
            this.load.audio('merge1', 'audioogg/merge1.ogg');
            this.load.audio('merge2', 'audioogg/merge2.ogg');
            this.load.audio('trow', 'audioogg/trow.ogg');
            this.load.audio('attach', 'audioogg/attach.ogg');
            this.load.audio('lose', 'audioogg/lose.ogg');
            this.load.audio('window', 'audioogg/window_swoosh.ogg');
            this.load.audio('win', 'audioogg/win.ogg');
            this.load.audio('coin', 'audioogg/coin.ogg');
            this.load.audio('prize', 'audioogg/prize.ogg');
            this.load.audio('shake', 'audioogg/shake_boom.ogg');
            this.load.audio('frenzy', 'audioogg/frenzy.ogg');
            this.load.audio('count', 'audioogg/count.ogg');
        }
        else {
            this.load.audio('music', 'audiomp3/music.mp3');
            this.load.audio('button', 'audiomp3/button.mp3');
            this.load.audio('merge0', 'audiomp3/merge0.mp3');
            this.load.audio('merge1', 'audiomp3/merge1.mp3');
            this.load.audio('merge2', 'audiomp3/merge2.mp3');
            this.load.audio('trow', 'audiomp3/trow.mp3');
            this.load.audio('attach', 'audiomp3/attach.mp3');
            this.load.audio('lose', 'audiomp3/lose.mp3');
            this.load.audio('window', 'audiomp3/window_swoosh.mp3');
            this.load.audio('win', 'audiomp3/win.mp3');
            this.load.audio('coin', 'audiomp3/coin.mp3');
            this.load.audio('prize', 'audiomp3/prize.mp3');
            this.load.audio('shake', 'audiomp3/shake_boom.mp3');
            this.load.audio('frenzy', 'audiomp3/frenzy.mp3');
            this.load.audio('count', 'audiomp3/count.mp3');
        }


      //  this.load.atlas('bgs', 'images/bgs.png', 'images/bgs.json');
        if(Base.MobileFlag)
            this.load.image('orient', 'images/rotateDevice.png');
        this.load.atlas('gfx', 'images/gfx.png', 'images/gfx.json');
        this.load.atlas('atlas', 'images/atlas.png', 'images/atlas.json');
        this.load.atlas('newimg', 'images/newimg.png', 'images/newimg.json');

        sdkHandler.trigger('restore', {
            key: 'merge01',
            callback: function(error, value) {
                if (error || value == null) {
                    this.loadedSave = true;
                    Base.Saves = { highscore: 0, music:true,sound:true,coins:0,help:true};
                    Base.Saves.coins = 100;
                } else {
                    this.loadedSave = true;
                    Base.Saves = JSON.parse(value);
                }
            }
        }, this);
    },

    loadComplete:  function ()  {


    },

    create: function () {
        this.preloadBar.cropEnabled = false;
    },

    checkScreenChange: function() {
        // CALLED EVERY 1/30 sec
        var clientWidth = Math.max(window.innerWidth, document.documentElement.clientWidth);
        var clientHeight = Math.max(window.innerHeight, document.documentElement.clientHeight);

        if(clientHeight!=Base.HeightWnd || clientWidth!=Base.WidthWnd) {

            Base.makeScreenAdjust(this.game); // it will call this correct function AdjustSize
        }
    },

    AdjustSize: function() {
        // BASE FUNCTION
     /*   if(this.logoImg!=null) {
            this.logoImg.y = Base.Height * Base.HCoeff / 2 - 110;
        }*/

        if(this.preloadBarBack!=null)
        {
            this.preloadBarBack.x = Base.Xc;
            this.preloadBarBack.y = Base.Yc;

            this.preloadBar.x = Base.Xc;
            this.preloadBar.y = Base.Yc;
            this.preloadBar.x -= this.PreloaderWidth/2;

            this.BgImg.x = Base.Xc;
            this.BgImg.y = Base.Yc;
            this.BgImg.scale.set(Base.WidthGame/200,Base.HeightGame/200);

            // this.preloadBarBack.y = Base.Height*Base.HCoeff/2 + 270;
           // this.preloadBar.y = Base.Height*Base.HCoeff/2 + 270;
        }
    },

    freezeGameGlobal : function()
    {
        if(Base.FreezeFlag)  return;
        this.game.input.enabled = false;
        Base.FreezeFlag = true;
        if(Base.MusicFlag) this.MuteMusic(true);
    },

    unFreezeGameGlobal : function()
    {
        if(!Base.FreezeFlag)  return;
        if(Base.sgFreezeFlag)  return;
      //  if(Base.WrongOrientFlag)  return;

        this.game.input.enabled = true;
        Base.FreezeFlag = false;
        if(Base.MusicFlag) this.MuteMusic(false);
    },

    freezeGame : function()
    {
        Base.sgFreezeFlag = true;
        this.freezeGameGlobal();
    },

    unfreezeGame : function()
    {
        Base.sgFreezeFlag = false;
        this.unFreezeGameGlobal();
    },

    runGame : function()
    {
        console.log("trying to runGame from Preloader !!!");
    },

    getScore : function()
    {
        console.log("trying to getScore from Preloader !!!");
    },

    //http://antongames.com/games/dunk/
    update: function () {

        switch (this.State) {
            case 0:

             /* if(this.loadedSave) this.BlackImgs[0].visible = false;
                if(this.cache.isSoundDecoded('button'))  this.BlackImgs[1].visible = false;
                if(this.cache.isSoundDecoded('merge0'))  this.BlackImgs[2].visible = false;
                if(this.cache.isSoundDecoded('trow')) this.BlackImgs[3].visible = false;
                if(this.cache.isSoundDecoded('attach')) this.BlackImgs[4].visible = false;
                if(this.cache.isSoundDecoded('music')) this.BlackImgs[5].visible = false;
                if(this.game.cache.checkImageKey('atlas')) this.BlackImgs[6].visible = false;
                if(this.game.cache.checkImageKey('gfx')) this.BlackImgs[7].visible = false;
                if(this.game.cache.checkBitmapFontKey('GoldFont')) this.BlackImgs[8].visible = false; */

                if (this.loadedSave &&
                    this.cache.isSoundDecoded('button') &&
                    this.cache.isSoundDecoded('merge0') &&
                    this.cache.isSoundDecoded('trow') &&
                    this.cache.isSoundDecoded('attach') &&
                    this.cache.isSoundDecoded('music') &&
                    this.game.cache.checkImageKey('atlas') &&
                    this.game.cache.checkImageKey('gfx') &&
                    this.game.cache.checkBitmapFontKey('GoldFont') &&
                    this.ready == false) {

                //    this.Group0Alpha = 1;
              //      this.Group0.setAll('alpha',this.Group0Alpha);

                    this.ready = true;
                    this.State = 1;
                    //  this.game.camera.flash(0xFFFFFF,400);

                    sdkHandler.trigger('loading.completed',
                        {
                            callback: function(error, user) {
                                if(error) {
                                    console.log('loading not complete');
                                }
                                else {
                                    // html.getDom('.mask').remove()
                                    // document.ge
                                   console.log('loading OK');
                                  //  this.sgLoadedFlag = true;

                                    this.game.time.events.remove(this.TimerEvt);
                                    Base.TimeStartGame = this.game.time.now;

                                    //  sgSettings.commands.runGame = this.StartGameMode.bind(this);
                                    //  sgSettings.commands.runGame();
                                    this.state.start('Game');
                                }
                            }
                        },
                        this);
                    //   this.sgLoadedFlag = true;

                  /* this.Group0Alpha = 0;
                     this.GroupBase.exist = false;
                     this.Group0.visible = false;
                     this.Group0.exist = false; */
               //    this.State = 2;

                }
                break;

            case 1:

              /*  if(this.sgLoadedFlag) {
                    this.game.time.events.remove(this.TimerEvt);
                    Base.TimeStartGame = this.game.time.now;

                  //  sgSettings.commands.runGame = this.StartGameMode.bind(this);
                  //  sgSettings.commands.runGame();
                     this.state.start('Game');
                } */

              /*  return;

                if(this.Group0Alpha<=0)
                {
                    this.game.time.events.remove(this.TimerEvt);

                  //  this.game.camera.flash(0xFFFFFF,400);
                    Base.TimeStartGame = this.game.time.now;
                 //   this.state.start('Game');
                 //   this.Group0Alpha = 0;
                 //   this.GroupBase.exist = false;
                 //   this.Group0.visible = false;
                 //   this.Group0.exist = false;

                    //  this.Group1Alpha = 0;
                    //   this.Group1.visible = false;
                    //  this.Group1.exist = false;
                    //  this.GroupBase.exist = false;
                    this.State = 2;
                }  */
                break;

        }
    }
};

